#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

typedef unsigned long int ulint;

struct ant
{
    ant() {}
    ant(int start, int pos, int dir) :
        start(start), pos(pos), dir(dir) {}
        
    int start;
    int pos;
    int dir;
};

static bool ant_at[2][2][100100];

static ant ants[100100];

static ulint L;
static ulint A; 

int main()
{
    char  dir;
    ulint pos;
    while (scanf("%lu %lu", &L, &A) != EOF)
    {
        memset(ant_at, false, sizeof(ant_at));
        for (uint a = 0; a < A; ++a)
        {
            scanf("%lu %c", &pos, &dir);
            ant_at[0][(dir == 'L') ? 0 : 1][pos]  = true;
            ants[a] = ant(pos, pos, (dir == 'L') ? -1 : 1);            
        }
        
        uint steps = 1;
        int A_curr = A;
        while (A_curr > 0)
        {
            for (uint a = 0; a < A; ++a)
            {
                if (ants[a].pos < 0 || ants[a].pos >= L)
                {
                    continue;
                }
                
                int npos = ants[a].pos + ants[a].dir;
                int cpos1 = npos;
                int cpos2 = npos + ants[a].dir;
                int my_dir = (ants[a].dir == -1) ? 0 : 1;
                int opp_dir = (ants[a].dir == -1) ? 1 : 0;
                
                if (cpos1 >= 0 && cpos1 < L && ant_at[steps % 2][opp_dir][cpos1])
                {
                    ant_at[1 - steps % 2][my_dir][ants[a].pos] = false;
                    ants[a].dir *= -1;
                    //ant_at[1 - steps % 2][opp_dir][cpos1] = ant_at[steps % 2][opp_dir][cpos1];
                    ant_at[1 - steps % 2][opp_dir][ants[a].pos] = true;
                }                
                else if (cpos2 >= 0 && cpos2 < L && ant_at[steps % 2][opp_dir][cpos2])
                {
                    ant_at[1 - steps % 2][my_dir][ants[a].pos] = false;
                    ants[a].pos += ants[a].dir;
                    ants[a].dir *= -1;
         
                    if (ants[a].pos < 0 || ants[a].pos >= L)
                    {
                        --A_curr;
                    }
                    else
                    {
                        ant_at[1 - steps % 2][opp_dir][ants[a].pos] = true;
                    }
                }
                else
                {
                    ant_at[1 - steps % 2][my_dir][ants[a].pos] = false;
                    ants[a].pos += ants[a].dir;
                    
                    if (ants[a].pos < 0 || ants[a].pos >= L)
                    {
                        --A_curr;
                    }
                    else
                    {
                        ant_at[1 - steps % 2][my_dir][ants[a].pos] = true;
                    }
                }
                
                if (A_curr == 0)
                {
                    printf("%d\n", ants[a].start);
                    break;
                }
                
            }
            for (uint l = 0; l < L; ++l)
            {
                ant_at[steps % 2][0][l] = false;
                ant_at[steps % 2][0][l] = false;
            }
            /*
            for (uint a = 0; a < A; ++a)
            {
                printf("%d ", ants[a].pos);
            }
            printf("\n");
            for (uint a = 0; a < A; ++a)
            {
                printf("%d ", ants[a].dir);
            }
            printf("\n");
            for (uint l = 0; l < L; ++l)
            {
                printf("%d ", ant_at[1 - steps % 2][0][l]);
            }
            printf("\n");
            for (uint l = 0; l < L; ++l)
            {
                printf("%d ", ant_at[1 - steps % 2][1][l]);
            }
            printf("\n");
            */
            ++steps;
        }
    }
}